BeerOverflow/BeerOverflow/BeerOverflow/Controllers/BeersController.cs
using System;
using System.Collections.Generic;
using System.Linq;
using System.Threading.Tasks;
using Microsoft.AspNetCore.Mvc;
using Microsoft.AspNetCore.Mvc.Rendering;
using Microsoft.EntityFrameworkCore;
using BeerOverflow.Data;
using BeerOverflow.Models;
using BeerOverflow.Services.Contracts;
using BeerOverflow.Web.Models;
using BeerOverflow.Services.DTO;
using Microsoft.AspNetCore.Authorization;

namespace BeerOverflow.Web.Controllers
{
    public class BeersController : Controller
    {
        private readonly BeerOverflowContext context;
        private readonly IBeerService beerService;
        private readonly IBreweryService breweryService;
        private readonly ICountryService countryService;
        private readonly IBeerTypeService beerTypeService;
        private readonly IReviewService reviewService;

        public BeersController(BeerOverflowContext context, IBeerService beerService,
            IBreweryService breweryService, ICountryService countryService, IBeerTypeService beerTypeService
            , IReviewService reviewService)
        {
            this.context = context;
            this.beerService = beerService;
            this.breweryService = breweryService;
            this.countryService = countryService;
            this.beerTypeService = beerTypeService;
            this.reviewService = reviewService;
        }

        // GET: Beers
        //public IActionResult Index(string sortOrder, string searchParams)
        //{
        //    ViewBag.NameSortParm = String.IsNullOrEmpty(sortOrder) ? "name_desc" : "";
        //    ViewBag.CountrySortParm = sortOrder == "Country" ? "country_desc" : "Country";
        //    ViewBag.BrewerySortParm = sortOrder == "Brewery" ? "brewery_dsec" : "Brewery";
        //    ViewBag.TypeSortParm = sortOrder == "Type" ? "type_dsec" : "Type";

        //    var beers = this.beerService.GetAllBeers()
        //        .Select(b => new BeerViewModel
        //        {
        //            Id = b.BeerDTOId,
        //            AlcoholPercentage = b.AlcoholPercentage,
        //            Brewery = b.Brewery.Name.ToString(),
        //            Country = b.Country.Name.ToString(),
        //            Rating = b.Ratings.Count == 0 ? 0 : b.Ratings.Select(r => r.RatingValue).Average(),
        //            RatingCount = b.Ratings.Count(),
        //            Name = b.Name,
        //            Type = b.Type.Name
        //        });

        //    if (!String.IsNullOrEmpty(searchParams))
        //    {
        //        beers = beers.Where(b => b.Brewery.ToLower().Contains(searchParams.ToLower()) || b.Country.ToLower().Contains(searchParams.ToLower())
        //                || b.Name.ToLower().Contains(searchParams.ToLower()) || b.Type.ToLower().Contains(searchParams.ToLower()));
        //    }

        //    if (beers == null)
        //    {
        //        return BadRequest();
        //    }

        //    switch (sortOrder)
        //    {
        //        case "name_desc":
        //            beers = beers.OrderByDescending(b => b.Name);
        //            break;
        //        case "Country":
        //            beers = beers.OrderBy(b => b.Country);
        //            break;
        //        case "country_desc":
        //            beers = beers.OrderByDescending(b => b.Country);
        //            break;
        //        case "Brewery":
        //            beers = beers.OrderBy(b => b.Brewery);
        //            break;
        //        case "brewery_desc":
        //            beers = beers.OrderByDescending(b => b.Brewery);
        //            break;
        //        case "Type":
        //            beers = beers.OrderBy(b => b.Type);
        //            break;
        //        case "type_desc":
        //            beers = beers.OrderByDescending(b => b.Type);
        //            break;
        //        default:
        //            beers = beers.OrderBy(s => s.Name);
        //            break;
        //    }

        //    return View(beers);
        //}

        // GET: Beers
        public async Task<IActionResult> Index(string sortOrder, string searchParams)
        {
            ViewBag.NameSortParm = String.IsNullOrEmpty(sortOrder) ? "name_desc" : "";
            ViewBag.CountrySortParm = sortOrder == "Country" ? "country_desc" : "Country";
            ViewBag.BrewerySortParm = sortOrder == "Brewery" ? "brewery_dsec" : "Brewery";
            ViewBag.TypeSortParm = sortOrder == "Type" ? "type_dsec" : "Type";

            var allBeers = await this.beerService.GetAllBeersAsync();
            var beers = allBeers
                .Select(b => new BeerViewModel
                {
                    Id = b.BeerDTOId,
                    AlcoholPercentage = b.AlcoholPercentage,
                    Brewery = b.Brewery.Name.ToString(),
                    Country = b.Country.Name.ToString(),
                    Rating = b.Ratings.Count == 0 ? 0 : b.Ratings.Select(r => r.RatingValue).Average(),
                    RatingCount = b.Ratings.Count(),
                    Name = b.Name,
                    Type = b.Type.Name
                });

            if (!String.IsNullOrEmpty(searchParams))
            {
                beers = beers.Where(b => b.Brewery.ToLower().Contains(searchParams.ToLower()) || b.Country.ToLower().Contains(searchParams.ToLower())
                        || b.Name.ToLower().Contains(searchParams.ToLower()) || b.Type.ToLower().Contains(searchParams.ToLower()));
            }

            if (beers == null)
            {
                return BadRequest();
            }

            beers = sortOrder switch
            {
                "name_desc" => beers.OrderByDescending(b => b.Name),
                "Country" => beers.OrderBy(b => b.Country),
                "country_desc" => beers.OrderByDescending(b => b.Country),
                "Brewery" => beers.OrderBy(b => b.Brewery),
                "brewery_desc" => beers.OrderByDescending(b => b.Brewery),
                "Type" => beers.OrderBy(b => b.Type),
                "type_desc" => beers.OrderByDescending(b => b.Type),
                _ => beers.OrderBy(s => s.Name),
            };
            return View(beers);
        }

        [Authorize(Roles = "User, Admin")]
        public async Task<IActionResult> LikeReviewAsync(int beerId, int userId)
        {
            await this.reviewService.LikeReviewAsync(beerId, userId);

            return RedirectToAction(nameof(Details), new { id = beerId });
        }

        [Authorize(Roles = "User, Admin")]
        public async Task<IActionResult> DislikeReviewAsync(int beerId, int userId)
        {
            await this.reviewService.DislikeReviewAsync(beerId, userId);

            return RedirectToAction(nameof(Details), new { id = beerId });
        }

        [Authorize(Roles = "User, Admin")]
        public async Task<IActionResult> AddToWishListAsync(int beerId, string userName)
        {
            await this.beerService.AddBeerToUserWishListAsync(beerId, userName);

            return RedirectToAction(nameof(Details), new { id = beerId });
        }

        [Authorize(Roles = "User, Admin")]
        public async Task<IActionResult> AddToDrankListAsync(int beerId, string userName)
        {
            await this.beerService.AddBeerToUserDrankListAsync(beerId, userName);

            return RedirectToAction(nameof(Details), new { id = beerId });
        }

        [Authorize(Roles = "User, Admin")]
        public async Task<IActionResult> AddReviewAsync(BeerViewModel beer)
        {
            var reviewDTO = new ReviewDTO
            {
                BeerId = beer.Id,
                ReviewText = beer.NewReview,
                Reviewer = User.Identity.Name
            };
            await this.reviewService.CreateReviewAsync(reviewDTO);

            return RedirectToAction(nameof(Details), new { id = beer.Id });
        }

        // GET: Beers/Details/5s
        //public IActionResult Details(int id)
        //{
        //    var beer = this.beerService.GetBeer(id);

        //    if (beer == null)
        //    {
        //        return NotFound();
        //    }

        //    var beerViewModel = new BeerViewModel
        //    {
        //        Id = beer.BeerDTOId,
        //        AlcoholPercentage = beer.AlcoholPercentage,
        //        Brewery = beer.Brewery.Name.ToString(),
        //        Country = beer.Country.Name.ToString(),
        //        Name = beer.Name,
        //        Rating = beer.Ratings.Count == 0 ? 0 : beer.Ratings.Select(r => r.RatingValue).Average(),
        //        RatingCount = beer.Ratings.Count(),
        //        Reviews = beer.Reviews.Select(re => new ReviewViewModel
        //        {
        //            Text = re.ReviewText,
        //            Reviewer = re.Reviewer,
        //            Dislikes = re.Dislikes,
        //            Likes = re.Likes,
        //            BeerId = re.BeerId,
        //            UserId = re.UserId
        //        }).ToList() ?? null,
        //        Type = beer.Type.Name
        //    };

        //    return View(beerViewModel);
        //}

        public async Task<IActionResult> Details(int id)
        {
            var beer = await this.beerService.GetBeerAsync(id);

            if (beer == null)
            {
                return NotFound();
            }

            var beerViewModel = new BeerViewModel
            {
                Id = beer.BeerDTOId,
                AlcoholPercentage = beer.AlcoholPercentage,
                Brewery = beer.Brewery.Name.ToString(),
                Country = beer.Country.Name.ToString(),
                Name = beer.Name,
                RatingUserNames = beer.Ratings.Select(r => r.UserName).ToList(),
                Rating = beer.Ratings.Count == 0 ? 0 : beer.Ratings.Select(r => r.RatingValue).Average(),
                RatingCount = beer.Ratings.Count(),

BeerOverflow/BeerOverflow/BeerOverflow/Views/Shared/_Layout.cshtml
<!DOCTYPE html>
<html lang="en">
<head>
    <meta charset="utf-8" />
    <meta name="viewport" content="width=device-width, initial-scale=1.0" />
    <title>@ViewData["Title"] - BeerOverflow.Web</title>
    <link rel="stylesheet" href="~/lib/bootstrap/dist/css/bootstrap.min.css" />
    <link rel="stylesheet" href="~/css/site.css" />
    <link href="~/css/site.css" rel="stylesheet" />
</head>
<body>
    <header>
        <nav class="navbar navbar-expand-lg navbar-light bg-transparent" style="background-color: aliceblue">
            <a class="navbar-brand" href="Home">
                <img src="~/images/beerlogo.svg" width="30" height="30" class="d-inline-block align-top" alt="">
                BeerOverflow
            </a>
            <button class="navbar-toggler" type="button" data-toggle="collapse" data-target="#navbarSupportedContent" aria-controls="navbarColor01" aria-expanded="false" aria-label="Toggle navigation">
                <span class="navbar-toggler-icon"></span>
            </button>

            <div class="collapse navbar-collapse" id="navbarSupportedContent">
                <ul class="navbar-nav mr-auto">
                    <li class="nav-item">
                        <a class="nav-link text-dark" asp-area="" asp-controller="Home" asp-action="Index">Home</a>
                    </li>
                    @*<li class="nav-item">
                            <a class="nav-link text-dark" asp-area="" asp-controller="Home" asp-action="Privacy">Privacy</a>
                        </li>*@
                    <li class="nav-item">
                        <a class="nav-link text-dark" asp-area="" asp-controller="Beers" asp-action="Index">Beers</a>
                    </li>
                    @if (User.Identity.IsAuthenticated)
                    {
                        <li class="nav-item">
                            <a class="nav-link text-dark" asp-area="" asp-controller="Breweries" asp-action="Index">Breweries</a>
                        </li>
                        <li class="nav-item">
                            <a class="nav-link text-dark" asp-area="" asp-controller="Countries" asp-action="Index">Countries</a>
                        </li>
                    }
                </ul>
                <partial name="_LoginPartial" />
            </div>
        </nav>
        @*<link rel="stylesheet" type="text/css" href="styles.css" />
        <style>
            body {
                background-image: url('images/pagesbackground.png');
                background-repeat: no-repeat;
                background-attachment: fixed;
                background-position: center;
                background-size: cover;
            }
        </style>*@
    </header>

    <div class="container-fluid">
        <main role="main" class="pb-3">

            @RenderBody()
        </main>
    </div>

    <footer class="border fixed-bottom text-muted" style="background-color: aliceblue">
        <div class="container">
            &copy; 2020 - Team Bolyarka - <a asp-area="" asp-controller="Home" asp-action="Privacy">Privacy</a>
        </div>
    </footer>
    <script src="~/lib/jquery/dist/jquery.min.js"></script>
    <script src="~/lib/bootstrap/dist/js/bootstrap.bundle.min.js"></script>
    <script src="~/js/site.js" asp-append-version="true"></script>
    @RenderSection("Scripts", required: false)
</body>
</html>